/* eslint-disable no-useless-constructor */
import RepositoryHandler from '~/driven/utils/helpers/repository-handler/repositoryHandler';
import { CreateProfileDtoReturnType, ICreateNewProfileData } from '../dto/protocols';
import createProfileDTO from '../dto/createProfileDTO';
import ICreateProfileRepo from './ICreateProfileRepo';
import { HttpHandler } from './protocols';

export default class CreateProfileRepo
  extends RepositoryHandler<CreateProfileDtoReturnType, string>
  implements ICreateProfileRepo
{
  constructor(httpHandler: HttpHandler) {
    super(httpHandler);
  }

  async execute(accountData: ICreateNewProfileData) {
    // create data in dto
    const dto = createProfileDTO(accountData);
    // call main http handler
    return await this.httpHandler(dto);
  }
}
