import CreateAccountRepo from '../create-account/data/repository/createAcountRepo';
import { HttpHandler as HttpAccountHandler } from '../create-account/data/repository/protocols';
import CreateProfileRepo from '../create-profile/data/repository/CreateRepositoryRepo';
import { HttpHandler as HttpProfileHandler } from '../create-profile/data/repository/protocols';
import CreateUserUsecase from '../usecase/createUserUsecase';

class CreateUserInfra {
  private httpAccountHandler: HttpAccountHandler;

  private httpProfileHandler: HttpProfileHandler;

  constructor(httpAccountHandler: HttpAccountHandler, httpProfileHandler: HttpProfileHandler) {
    this.httpAccountHandler = httpAccountHandler;
    this.httpProfileHandler = httpProfileHandler;
  }

  execute() {
    // make account repositroy ready
    const accountRepository = new CreateAccountRepo(this.httpAccountHandler);
    // make profile repository ready
    const profileRepository = new CreateProfileRepo(this.httpProfileHandler);
    // make usecase ready
    const usecase = new CreateUserUsecase(accountRepository, profileRepository);
    // return prepared method to call and create user
    return usecase;
  }
}

export default CreateUserInfra;
