import { INewUserData } from '~/business-logic/core/users/create-user/create-account/data/dto/protocols';
import { CreateAcountResponseApi } from '~/business-logic/core/users/create-user/create-account/data/response-object/protocols';
import createUserPort from '~/business-logic/core/users/create-user/ports';
import { HTTPPovider } from '~/driven/boundaries/http-boundary/httpBoundary';
import { HttpOptionsType } from '~/driven/boundaries/http-boundary/protocols';
import { apiUrls } from '~/driven/utils/configs/appConfig';

const createAccountAdapter = (): createUserPort['httpAccountHandler'] => {
  // make url
  const url = apiUrls.core.createUserAccount;
  // call http provider
  const httpProvider = new HTTPPovider();

  const httpHandler = (newUserData: INewUserData) => {
    // api options
    const httpOptions: HttpOptionsType = {
      url,
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
      },
      data: newUserData,
    };
    return httpProvider.request<CreateAcountResponseApi>(httpOptions);
  };

  return httpHandler;
};

export default createAccountAdapter;
