import useSwr from 'swr';
import StateManagementProvider from './stateManagementProvider';

export default class SwrBoundary implements StateManagementProvider {
  useGetQuery<DataType>(
    key: string,
    httpHandler: () => Promise<DataType>,
  ): {
    data: DataType | undefined;
    isLoading: boolean;
    error?: string | undefined;
  } {
    return useSwr(key, httpHandler);
  }
}
