import StateManagementService from '~/driven/boundaries/state-management';
import { errorHandlingStateTypes, UIErrorHandling } from './protocols/globalHelpersProtocols';

export const UIErrorHandlingFactory = <DATA_RESPONSE>({
  state,
  message,
  data,
}: {
  state: `${errorHandlingStateTypes}`;
  message: string;
  data: DATA_RESPONSE;
}): UIErrorHandling<DATA_RESPONSE> => ({
  data,
  message,
  state,
});

export const prepareStateManagementForVM = <ReturnType>(apiUrl: string, model: () => Promise<ReturnType>) => {
  const stateManagement = StateManagementService.swr();

  const useGetPlacesList = () => stateManagement.useGetQuery(apiUrl, model);

  return useGetPlacesList;
};

export const checkPhoneNumberInput = (newValue: string) => {
  return (Number.isFinite(+newValue) || newValue === '+') && newValue.length <= 12;
};
