import React from 'react';
import PrimaryButton from '~/driven/utils/components/buttons/primary-button/PrimaryButton';
import SimpleInput from '~/driven/utils/components/inputs/simple-input/SimpleInput';
import { staticMessages } from '~/driven/utils/constants/staticMessages';
import ICreateUserViewProps from './protocols';

export default function CreateUserView(props: ICreateUserViewProps) {
  const { onSubmit, inputNames, stateHandler } = props;
  const { inputStates, inputsSetStates } = stateHandler;

  const inputs = inputNames.map((inputName) => {
    const title = staticMessages.global[inputName] as string;
    return (
      <SimpleInput
        inputData={{
          title,
          name: inputName,
        }}
        stateHanlder={{
          setState: inputsSetStates,
          state: inputStates[inputName],
        }}
        key={inputName}
        className='mb-4 w-[48%]'
      />
    );
  });
  return (
    <form onSubmit={onSubmit} className='px-4 my-8'>
      <div className='flex flex-wrap w-full gap-4'>{inputs}</div>
      <div className='flex'>
        <PrimaryButton onClick={() => null} title={staticMessages.global.submit} />
      </div>
    </form>
  );
}
