import React from 'react';
import getUsersAdapter from '~/driven/adapters/get-users-adapter/getUsersAdapter';
import getUsers from '~/business-logic/core/users/get-users';
import UsersModel from '~/business-logic/core/users/common/data/model/usersModel';
import { prepareStateManagementForVM } from '~/driven/utils/helpers/globalHelpers';
import useUsersListVM from '../viewmodel/usersListVM';
import UsersListView from '../view/UsersListView';
import usersListModel from '../model/usersListModel';

const prepareTheLogicForModel = () => {
  const gettingUsersDrivenAdapter = getUsersAdapter();
  const { url } = gettingUsersDrivenAdapter;
  const getingusersLogic = getUsers(gettingUsersDrivenAdapter);
  return { getingusersLogic, url };
};

export default function UsersList() {
  const { getingusersLogic, url } = prepareTheLogicForModel();
  const usersModel = async () => await usersListModel(getingusersLogic);
  const useGetusersList = prepareStateManagementForVM<UsersModel>(
    url,
    usersModel
  );
  const { selectedRowId, setSelectedRowId, usersData } = useUsersListVM({
    useGetusersList,
  });
  return (
    <UsersListView
      usersList={usersData}
      selectedRowId={selectedRowId}
      setSelectedRowId={setSelectedRowId}
    />
  );
}
